// 002 u_calcul_charges_sarl_2
// 09 jan 2020

// -- (C) John COLIBRI 2020
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_calcul_charges_sarl_2;
  Interface
    Uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs
        , StdCtrls, FileCtrl, ExtCtrls, ComCtrls
        ;

    type TForm1=
             class(TForm)
                 command_panel: tPanel;
                 exit_panel: tPanel;
                 exit_: tButton;
                 clear_: tButton;
                 help_: tButton;
                 dir_pagecontrol: tPageControl;
                 dir_tabsheet: tTabSheet;
                 favorites_panel: tPanel;
                 DirectoryListbox1: tDirectoryListbox;
                 dir_file_splitter: tSplitter;
                 file_panel: tPanel;
                 update_filelistbox_: tButton;
                 paste_directory_listbox_: tButton;
                 FileListbox1: tFileListbox;
                 bottom_panel: tPanel;
                 left_splitter: tSplitter;
                 display_pagecontrol: tPageControl;
                 display_tabsheet: tTabSheet;
                 Memo1: tMemo;
    Label1: TLabel;
    salaire_edit_: TEdit;
    compurte_: TButton;
    _30000_: TRadioButton;
    _60000_: TRadioButton;
    _120000_: TRadioButton;
    cotisations_sociales_obligatoire_edit_: TEdit;
    Label2: TLabel;
    monthly_: TCheckBox;
    _39600: TRadioButton;
                 Procedure Form1Create(Sender: tObject);
                 Procedure Form1Close(Sender: TObject; var Action: TCloseAction);
                 Procedure exit_Click(Sender: tObject);
                 Procedure clear_Click(Sender: tObject);
                 Procedure help_Click(Sender: tObject);
                 Procedure DirectoryListbox1Change(Sender: tObject);
                 Procedure update_filelistbox_Click(Sender: tObject);
                 Procedure paste_directory_listbox_Click(Sender: tObject);
                 Procedure FileListbox1Click(Sender: tObject);
    procedure compurte_Click(Sender: TObject);
    procedure _30000_Click(Sender: TObject);
               private
                 procedure handle_favorite_path_click(p_path, p_extension: String);
               public
             end; // TForm1

    var Form1: tForm1= Nil;

  implementation
    Uses  ClipBrd
        , u_c_display, u_c_log, u_types_constants
        , u_help
        , u_panel
        , u_c_favorite_path_list
        , u_exe
        , u_file, u_dir
        , u_c_ini_file
        , u_handle_files_in_dirs

        , u_c_calcul_charges_sarl

        ;

    {$R *.DFM}

    Const k_xxx_path=                'D:\prog\xxx\';
          k_xxx_file_name=           'pascal.pas';
          k_xxx_path_ini_key=        'ini_xxx_path';
          k_xxx_file_name_ini_key=   'ini_xxx_file_name';

    Var g_path:          String= k_xxx_path;
        g_file_name:     String= k_xxx_file_name;
        g_c_ini_file:    c_ini_file= Nil;
        g_file_count:    Integer= 0;
        g_c_favorite_path_list: c_favorite_path_list= Nil;

        g_c_calcul_charges_sarl: c_calcul_charges_sarl= Nil;

    procedure display_path_and_file;
      begin
        Form1.Caption:= g_path+ g_file_name;
      end; // display_path_and_file

    procedure my_call_back(p_level: Integer; p_path, p_file_name: String;
        p_pt_data: Pointer);
      begin
        // -- CAUTION if 2 dirs
        // g_path:= p_path; g_file_name:= p_file_name;
        display_path_and_file;
        // Form1.load_Click(Nil);

        Inc(g_file_count);

        display('  '+ p_file_name);

        if Pos('sarl', p_file_name)> 0
          then begin
              g_c_calcul_charges_sarl.Free;
              g_c_calcul_charges_sarl:=  c_calcul_charges_sarl.create_calcul_charges_sarl('', p_path, p_file_name);

              with g_c_calcul_charges_sarl do
              begin
                load_parameters;
                display_parameters;
              end;
            end
      end; // my_call_back

    // -- events

    procedure TForm1.Form1Create(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
//        check_name('D:\programs\fr_zip\zip_calcul_charges_sarl_2\fr\admin\calcul_charges_sarl_2\_exe
        initialize_default_log;
        g_c_ini_file:= c_ini_file.create_ini_file('');
        with g_c_ini_file do
        begin
          // -- whatever is in "fig_ini.txt"
          load_from_default_file;

          // -- initialize the variables with INI or, if none, with constants
          g_path:= f_initialize_parameter(k_xxx_path_ini_key, k_xxx_path);
          g_file_name:= f_initialize_parameter(k_xxx_file_name_ini_key, k_xxx_file_name);
        end; // with g_c_ini_file
        display_path_and_file;

        // check_name(k_initial_directory);
        // DirectoryListBox1.Directory:= k_initial_directory;

        g_c_favorite_path_list:= c_favorite_path_list.create_favorite_path_list(
            f_exe_path+ 'favorites\'+ f_exe_pure_project_name+ '_favorites.txt',
            favorites_panel, handle_favorite_path_click);

        set_directory_listbox_directory(DirectoryListBox1, g_path);
        with FileListBox1, Items do
          ItemIndex:= IndexOf(g_file_name);

         _30000_Click(Nil);
      end; // Form1Create

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    procedure TForm1.update_filelistbox_Click(Sender: TObject);
      begin
        FileListBox1.Update;
      end; // update_filelistbox_Click

    procedure TForm1.paste_directory_listbox_Click(Sender: TObject);
      begin
        set_directory_listbox_directory(DirectoryListBox1, ClipBoard.AsText);
      end; // TForm1.paste_directory_listbox_Click

    procedure TForm1.Form1Close(Sender: TObject; var Action: TCloseAction);
      begin
        g_c_ini_file.save_to_default_file;
      end; // Form1Close

    // -- call handler

    procedure TForm1.DirectoryListBox1Change(Sender: TObject);
      begin
        with DirectoryListBox1 do
          g_path:= GetItemPath(ItemIndex)+ '\';
        g_c_ini_file.set_parameter(k_xxx_path_ini_key, g_path);
        // display_path_and_file;
      end; // DirectoryListBox1Change

    procedure TForm1.FileListBox1Click(Sender: TObject);
      // -- the file clicked in the bottom list_box
      // var l_path, l_name: String;
      begin
        // l_path:= DirectoryListBox1.Directory;
        with FileListbox1 do
          g_file_name:= Items[ItemIndex];
        // Form1.load_Click(Nil);
        g_c_ini_file.set_parameter(k_xxx_file_name_ini_key, g_file_name);

        g_file_count:= 0;
        my_call_back(0, g_path, g_file_name, Nil);
        // TODO update the ini 
        g_c_ini_file.save_to_default_file;
      end; // FileListBox1Click

    procedure handle_the_files(p_dir_handling_types: t_dir_handling_types);
      var l_extension: String;
          l_path: String;
      begin
        l_path:= f_without_ending_slash(g_path);

        l_extension:= Form1.FileListBox1.Mask;
        Delete(l_extension, 1, 1);
        l_extension:= UpperCase(l_extension);

        display_line;
        display('handle_non_rec of '+ l_path+ ' '+ l_extension);
        display_line;
        g_file_count:= 0;

        handle_all_files_recursive(1, l_path, l_extension,
            p_dir_handling_types, my_call_back, Nil);

        display_line;
        display(Format('FINISHED %3d ', [g_file_count]));
      end; // handle_the_files

    procedure tForm1.handle_favorite_path_click(p_path, p_extension: String);
      begin
        set_directory_listbox_directory(DirectoryListbox1, p_path);
      end; // handle_favorite_path_click

    procedure TForm1.help_Click(Sender: TObject);
      begin
        display_help;
      end; // help_Click

    // -- actions

    procedure TForm1._30000_Click(Sender: TObject);
      begin
        if _30000_.Checked
          then begin
              salaire_edit_.Text:= '30000';
              cotisations_sociales_obligatoire_edit_.Text:= '16965';
              cotisations_sociales_obligatoire_edit_.Text:= '8800';
              cotisations_sociales_obligatoire_edit_.Text:=  FloatToStr(0.45* StrToFloat(cotisations_sociales_obligatoire_edit_.Text));
              cotisations_sociales_obligatoire_edit_.Text:= '13400';
            end
          else
            if _60000_.Checked
              then begin
                  salaire_edit_.Text:= '60000';
                  cotisations_sociales_obligatoire_edit_.Text:= '16300';
                  cotisations_sociales_obligatoire_edit_.Text:=  FloatToStr(0.45* StrToFloat(cotisations_sociales_obligatoire_edit_.Text));
                  cotisations_sociales_obligatoire_edit_.Text:= '26400';
                end
              else
                if _120000_.Checked
                  then begin
                      salaire_edit_.Text:= '120000';
                      cotisations_sociales_obligatoire_edit_.Text:= '45400';
                    end
                  else
      end;

    procedure TForm1.compurte_Click(Sender: TObject);
      begin
        if g_c_calcul_charges_sarl= Nil
          then
            with FileListBox1, Items do
              if ItemIndex>= 0
                then OnClick(Nil);

        if g_c_calcul_charges_sarl<> Nil
          then
            with g_c_calcul_charges_sarl do
            begin
              if monthly_.Checked
                then m_month_count:= 12
                else m_month_count:= 1;

              compute_charges(StrToFloat(salaire_edit_.Text),
                  StrToFloat(cotisations_sociales_obligatoire_edit_.Text));
            end
      end;

end. // calcul_charges_sarl

